const { options } = require('joi');
const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    enabled,
    delete: _delete
};

/**
 * Format an array of bloodPressures by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} bloodPressures - The array of bloodPressures to format.
 * @returns {Promise<Object[]>} - The formatted array of bloodPressures.
 */
const formatWithModifier = async (bloodPressures) => {
    return Promise.all(
        bloodPressures.map(async (bloodPressure) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: bloodPressure.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...bloodPressure,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Get all bloodPressures with their respective companies.
 * @param {Object} params - An object that contains parameters to filter the bloodPressures.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the bloodPressures and a success flag.
 * @example
 * const result = await getAll({ companiesId: [1, 2] });
 * console.log(result);
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        let bloodPressures = [];
        bloodPressures = await dbSAPPS.BloodPressure.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'display_name']
                }
            ]
        });

        bloodPressures = bloodPressures.map(bloodPressure => {
            return {
                ...bloodPressure.dataValues,
                company_name: bloodPressure?.company?.display_name
            }
        });

        bloodPressures = await formatWithModifier(bloodPressures);

        return {
            bloodPressures,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage,
        };
    }
}

/**
 * Get bloodPressures with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the bloodPressures.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the bloodPressures and a success flag.
 * @example
 * const result = await option({ companiesId: [1, 2] });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        let options = [];
        options = await dbSAPPS.BloodPressure.findAll({
            where: filterConditions,
            attributes: ['id', 'name', 'display_name'],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'name', 'display_name']
                }
            ],
            order: [['name', 'ASC']]
        });

        options = options.map(option => {
            return {
                ...option.dataValues,
                company_name: option?.company?.display_name
            }
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active bloodPressures
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */
async function count(params) {
    try {
        // filter
        const filterConditions = {};

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        const count = await dbSAPPS.BloodPressure.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new bloodPressure
 * 
 * @param {object} params - bloodPressure data to be created.
 * @param {string} params.name - bloodPressure name.
 * @param {string} params.display_name - bloodPressure display name.
 * @param {boolean} [params.enabled=true] - bloodPressure enabled status.
 * @param {number} [params.creation=Date.now()] - bloodPressure creation timestamp.
 * @param {number} [params.modified=Date.now()] - bloodPressure last modification timestamp.
 * @param {number} [params.owner=1] - User ID of the bloodPressure owner.
 * @param {number} [params.modified_by=1] - User ID of the last modifier of the bloodPressure.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the bloodPressure creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingName = await dbSAPPS.BloodPressure.findOne({
            where: { name: params.name, company_id: params.company_id },
            transaction
        });
        if (existingName) {
            return {
                success: false,
                message: `"${params.name}" is already taken.`
            };
        }

        const existingDisplayName = await dbSAPPS.BloodPressure.findOne({
            where: { display_name: params.display_name, company_id: params.company_id },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.BloodPressure.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing bloodPressure
 * 
 * @param {number} id - bloodPressure ID to be updated.
 * @param {object} params - bloodPressure data to be updated.
 * @param {string} [params.name] - bloodPressure name.
 * @param {string} [params.display_name] - bloodPressure display name.
 * @param {boolean} [params.enabled] - bloodPressure enabled status.
 * @param {number} [params.creation] - bloodPressure creation timestamp.
 * @param {number} [params.modified] - bloodPressure last modification timestamp.
 * @param {number} [params.owner] - User ID of the bloodPressure owner.
 * @param {number} [params.modified_by] - User ID of the last modifier of the bloodPressure.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the bloodPressure update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const bloodPressure = await dbSAPPS.BloodPressure.findByPk(id);
        if (!bloodPressure) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingName = await dbSAPPS.BloodPressure.findOne({
            where: {
                name: params.name,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingName) {
            return {
                success: false,
                message: `"${params.name}" is already taken.`
            };
        }

        const existingDisplayName = await dbSAPPS.BloodPressure.findOne({
            where: {
                display_name: params.display_name,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await bloodPressure.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Enable or disable a bloodPressure
 * @param {number} id - the id of the bloodPressure
 * @param {object} params - the update data
 * @param {boolean} params.enabled - the enabled status of the bloodPressure
 * @param {number} [params.modified_by] - the modified by of the bloodPressure
 * @param {Date} [params.modified] - the modified of the bloodPressure
 * @returns {Promise<object>} - the result of the update
 */
async function enabled(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const bloodPressure = await dbSAPPS.BloodPressure.findByPk(id);
        if (!bloodPressure) return { success: false, message: 'ID not found!' };

        // update params
        const updateData = {};
        updateData.enabled = params.enabled;
        if (params.modified_by) updateData.modified_by = params.modified_by;
        if (params.modified) updateData.modified = params.modified;

        // save
        await bloodPressure.update(updateData, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a bloodPressure
 * @param {number} id - the id of the bloodPressure
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const bloodPressure = await dbSAPPS.BloodPressure.findByPk(id, { transaction });
        if (!bloodPressure) return { success: false, message: 'ID not found!' };

        // delete
        await bloodPressure.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
